=== debian/changelog ===
mlton (20130715-3) unstable; urgency=low

  * Build-depend only on mlton-compiler and mlton-tools
   * Buildds got stuck by looking at the mlton all package
  * Remove heap-size hacks; debian buildds have >2GB RAM now
  * Source-only upload to ensure full rebuild

 -- Wesley W. Terpstra <terpstra@debian.org>  Sun, 18 Dec 2016 22:48:17 +0100

mlton (20130715-2) unstable; urgency=low

  * Remove policy-problematic smlnj HTML4 from the package
  * Remove ports for hurd-i386 (unreliable) and ia64 (dead)
  * Add arm64 port (use supplied patch; closes: #791936)
  * Add mips64el port (needed a complete arch patch)
  * Add ppc64el port (needs bin/platform patch)
  * Track s390 port name change to s390x
  * Fix kfreebsd ports (removed getpgrp work-around)
  * Added build dependency on librsvg2-bin

 -- Wesley W. Terpstra <terpstra@debian.org>  Sat, 17 Dec 2016 03:39:49 +0100

mlton (20130715-1) unstable; urgency=low

  * New upstream release (closes: #762143)
  * Always build PIC on Linux (closes: #837567)
  * Bump debhelper compat to 9 (disable empty dbgsym packages)
  * Bump standards version to 3.9.8 (use DEB_HOST_MULTIARCH)
  * Replace README link with contents to help dh_installdocs

 -- Wesley W. Terpstra <terpstra@debian.org>  Fri, 9 Dec 2016 12:11:32 +0200
